public class Bild {

  PGraphics pg;
  UndoSpeicher undoSpeicher;
  boolean wirdBearbeitet = false;
   
  Bild(int breite, int hoehe) {
    pg = createGraphics(breite, hoehe);
    pg.beginDraw();
    pg.colorMode(RGB, 100);
    pg.background(100);
    pg.endDraw();
    undoSpeicher = new UndoSpeicher(this);
  }
  
  void anzeigen() {
    image(pg, dXBild, dYBild);
  }
  
  void malenBeenden(){
    wirdBearbeitet = false;
    undoSpeicher.save();
  }
  
  void bildGroesseAendern(int breite, int hoehe) {
    PGraphics pgNeu = createGraphics(breite, hoehe);
    pgNeu.beginDraw();
    pgNeu.colorMode(RGB, 100);
    pgNeu.background(100);
    pgNeu.image(pg, 0, 0);
    pgNeu.endDraw();
    pg = pgNeu;
    aktualisiereFensterGroesse();
  }
  
  void undo(){
    PImage letztesBild = undoSpeicher.undo();
    bildGroesseAendern(letztesBild.width, letztesBild.height);
    pg.beginDraw();
    pg.image(letztesBild, 0, 0);
    pg.endDraw(); 
  }
  
  void loeschen() {
    pg.beginDraw();
      pg.fill(100);
      pg.noStroke();
      pg.rect(0, 0, pg.width, pg.height);
    pg.endDraw();
    malenBeenden();   
  }
  
  boolean mausImBild(){
    return mouseX > dXBild
    && mouseX <  bild.pg.width + dXBild
    && mouseY > dYBild
    && mouseY < dYBild +  bild.pg.height;
  }

  void speichern() {
    selectOutput("Bild Speichern:", "speichernAbschliessen", null, this);
  }

  void speichernAbschliessen(File file) {
    if (file != null) {
      pg.save(file.getPath());
    }
  }
  
  void oeffnen() {
    selectInput("Bild Öffnen:", "oeffnenAbschliessen", null, this);
  }

  public void oeffnenAbschliessen(File file) {
    if (file != null) {
      PImage geladenesBild = loadImage(file.getPath());
      bildGroesseAendern(geladenesBild.width, geladenesBild.height);
      pg.beginDraw();
      pg.image(loadImage(file.getPath()), 0, 0);
      pg.endDraw();
      undoSpeicher.save();
    }
  }
  
}